diff --git a/src/BOPTest/BOPTest_LowCommands.cxx b/src/BOPTest/BOPTest_LowCommands.cxx
index b863f41..f682861 100644
--- a/src/BOPTest/BOPTest_LowCommands.cxx
+++ b/src/BOPTest/BOPTest_LowCommands.cxx
@@ -21,14 +21,18 @@
 #include <BRep_ListIteratorOfListOfCurveRepresentation.hxx>
 #include <BRep_TEdge.hxx>
 #include <BRep_Tool.hxx>
+#include <BRepAdaptor_Surface.hxx>
+#include <BRepBuilderAPI_MakePolygon.hxx>
 #include <BRepClass3d_SolidClassifier.hxx>
 #include <BRepClass_FaceClassifier.hxx>
+#include <BRepTopAdaptor_FClass2d.hxx>
+#include <CSLib_Class2d.hxx>
 #include <DBRep.hxx>
 #include <Draw.hxx>
 #include <DrawTrSurf.hxx>
+#include <Geom2d_BSplineCurve.hxx>
 #include <gp_Pnt.hxx>
 #include <gp_Pnt2d.hxx>
-#include <IntTools_FClass2d.hxx>
 #include <TCollection_AsciiString.hxx>
 #include <TopAbs_State.hxx>
 #include <TopoDS.hxx>
@@ -54,6 +58,8 @@ static  Standard_Integer bclassify   (Draw_Interpretor& , Standard_Integer , con
 static  Standard_Integer b2dclassify (Draw_Interpretor& , Standard_Integer , const char** );
 static  Standard_Integer b2dclassifx (Draw_Interpretor& , Standard_Integer , const char** );
 static  Standard_Integer bhaspc      (Draw_Interpretor& , Standard_Integer , const char** );
+static  Standard_Integer IsHole      (Draw_Interpretor&, Standard_Integer, const char**);
+static  Standard_Integer polyclassify( Draw_Interpretor&, Standard_Integer, const char** );
 
 //=======================================================================
 //function : LowCommands
@@ -68,12 +74,25 @@ static  Standard_Integer bhaspc      (Draw_Interpretor& , Standard_Integer , con
   const char* g = "BOPTest commands";
   theCommands.Add("bclassify"    , "use bclassify Solid Point [Tolerance=1.e-7]",
                   __FILE__, bclassify   , g);
-  theCommands.Add("b2dclassify"  , "use b2dclassify Face Point2d [Tol] ",
+  theCommands.Add("b2dclassify", "use b2dclassify Face Point2d "
+                  "[-t Tol3D = <FaceToler>] :\n "
+                  "Tol3D is 3D-tolerance used for check ON-status.",
                   __FILE__, b2dclassify , g);
-  theCommands.Add("b2dclassifx"  , "use b2dclassifx Face Point2d [Tol] ",
+  theCommands.Add("b2dclassifx"  , "use b2dclassifx Face Point2d "
+                  "[-t Tol3D = <FaceToler>] [-na] :\n "
+                  "Enter the command w/o arguments to obtain help.",
                   __FILE__, b2dclassifx , g);
   theCommands.Add("bhaspc"       , "use bhaspc Edge Face [do]",
                   __FILE__, bhaspc      , g);
+
+  theCommands.Add("ishole", "Use: ishole face [-t toler3D = <FaceToler>]: "
+                      "Checks if the face is hole", __FILE__, IsHole, g);
+
+  theCommands.Add("polyclassify", "Use: polyclassify [-s] -c px py -t tolU tolV "
+                  "-p px1 py1 -p px2 py2 ...:\n"
+                   "Classifies the point relatively to the polygon. "
+                   "Enter the command w/o arguments to obtain detail help.",
+                   __FILE__, polyclassify, g );
 }
 
 
@@ -87,7 +106,10 @@ Standard_Integer b2dclassifx (Draw_Interpretor& theDI,
                               const char**      theArgVec)
 {
   if (theArgNb < 3)  {
-    theDI << " use b2dclassifx Face Point2d [Tol]\n";
+    theDI << "Use b2dclassifx Face Point2d [-t Tol3D = <FaceToler>] [-na]:\n";
+    theDI << "Tol3D is 3D-tolerance used for check ON-status;\n"
+             "The option \"-na\" disables adjustment of 2d point in "
+             "the domain of periodic face.\n";
     return 1;
   }
 
@@ -100,16 +122,36 @@ Standard_Integer b2dclassifx (Draw_Interpretor& theDI,
     theDI << " Shape type must be FACE\n";
     return 1;
   }
-  TopAbs_State aState;
-  gp_Pnt2d aP (8., 9.);
+  
+  gp_Pnt2d aP;
   //
   DrawTrSurf::GetPoint2d (theArgVec[2], aP);
   const TopoDS_Face&  aF   = TopoDS::Face(aS);
-  const Standard_Real aTol = (theArgNb == 4) ? 
-    Draw::Atof (theArgVec[3]) : BRep_Tool::Tolerance (aF);
-  //
-  IntTools_FClass2d aClassifier(aF, aTol);
-  aState=aClassifier.Perform(aP);
+  
+  Standard_Real aTol3D = BRep_Tool::Tolerance(aF);
+  Standard_Boolean isReqToAdjust = Standard_True;
+
+  for (Standard_Integer aCurrArg = 3; aCurrArg < theArgNb; aCurrArg++)
+  {
+    if (theArgVec[aCurrArg][0] != '-')
+      continue;
+
+    switch (theArgVec[aCurrArg][1])
+    {
+    case 't' :
+      aTol3D = Draw::Atof(theArgVec[++aCurrArg]);
+      break;
+    case 'n' :
+      if(!strncmp(theArgVec[aCurrArg], "-na", 3))
+        isReqToAdjust = Standard_False;
+      break;
+    default:
+      break;
+    }
+  }
+
+  BRepTopAdaptor_FClass2d aClassifier(aF, aTol3D);
+  const TopAbs_State aState = aClassifier.Perform(aP, isReqToAdjust);
   PrintState (theDI, aState);
   //
   return 0;
@@ -124,7 +166,7 @@ Standard_Integer b2dclassify (Draw_Interpretor& theDI,
                               const char**      theArgVec)
 {
   if (theArgNb < 3)  {
-    theDI << " use b2dclassify Face Point2d [Tol]\n";
+    theDI << " use b2dclassify Face Point2d [-t Tol3D = <FaceToler>]\n";
     return 1;
   }
 
@@ -138,21 +180,62 @@ Standard_Integer b2dclassify (Draw_Interpretor& theDI,
     return 1;
   }
   //
-  gp_Pnt2d aP (8., 9.);
+  gp_Pnt2d aP;
   //
   DrawTrSurf::GetPoint2d (theArgVec[2], aP);
   const TopoDS_Face&  aF   = TopoDS::Face(aS);
-  const Standard_Real aTol = (theArgNb == 4) ? 
-    Draw::Atof (theArgVec[3]) : BRep_Tool::Tolerance (aF);
-  
+  Standard_Real aTol3D = BRep_Tool::Tolerance(aF);
+
+  if ((theArgNb > 3) && (theArgVec[3][0] == '-') && (theArgVec[3][1] == 't'))
+    aTol3D = Draw::Atof(theArgVec[4]);
+
   BRepClass_FaceClassifier aClassifier;
-  aClassifier.Perform(aF, aP, aTol);
+  aClassifier.Perform(aF, aP, aTol3D);
   PrintState (theDI, aClassifier.State());
   //
   return 0;
 }
 
 //=======================================================================
+//function : IsHole
+//purpose  : 
+//=======================================================================
+Standard_Integer IsHole(Draw_Interpretor& theDI,
+                        Standard_Integer  theArgNb,
+                        const char**      theArgVec)
+{
+  if (theArgNb < 2)
+  {
+    theDI << "Use: ishole face [-t Tol3D = <FaceToler>]\n";
+    return 1;
+  }
+
+  TopoDS_Face aF = TopoDS::Face(DBRep::Get(theArgVec[1]));
+
+  Standard_Real aTol = BRep_Tool::Tolerance(aF);
+  for (Standard_Integer i = 2; i < theArgNb; i++)
+  {
+    if ((theArgVec[i][0] == '-') && (theArgVec[i][1] == 't'))
+    {
+      aTol = Draw::Atof(theArgVec[++i]);
+    }
+  }
+
+  BRepTopAdaptor_FClass2d aClassifier(aF, aTol);
+  if (aClassifier.PerformInfinitePoint() == TopAbs_IN)
+  {
+    theDI << "The face is hole\n";
+  }
+  else
+  {
+    theDI << "The face is not hole\n";
+  }
+
+  return 0;
+}
+
+
+//=======================================================================
 //function : bclassify
 //purpose  : 
 //=======================================================================
@@ -188,6 +271,99 @@ Standard_Integer bclassify (Draw_Interpretor& theDI,
 }
 
 //=======================================================================
+//function : polyclassify
+//purpose  : 
+//=======================================================================
+Standard_Integer polyclassify(Draw_Interpretor& theDI,
+                              Standard_Integer  theArgNb,
+                              const char**      theArgVec)
+{
+  if(theArgNb < 9)
+  {
+    //                0          1  2  3  4  5    6    7       8
+    theDI << "Use: polyclassify -c px py -t tolU tolV -p <2D B-spline curve>\n"
+             "Classifies the point (px, py) relatively to the 2D-polygon\n"
+             "(set by \"-p\"-option) using UV-tolerances tolU and tolV.\n"
+             "This polygon is built from the poles of the 2D B-spline curve\n"
+             "(this curve must be 1st-degree-curve).\n"
+             "Such polygon can be created by \"2dpolyline\"-DRAW-command.";
+             "The algorithm will always close this polygon before classification.\n";
+    return 1;
+  }
+
+  gp_Pnt2d aClassifPnt;
+  Standard_Real aTolU = 0.0, aTolV = 0.0;
+
+  Handle(Geom2d_BSplineCurve) aCurv;
+
+  for(Standard_Integer i = 1; i < theArgNb; i++)
+  {
+    if(theArgVec[i][0] != '-')
+      continue;
+
+    switch(theArgVec[i][1])
+    {
+      case 'c':
+      {
+        const Standard_Real aX = Draw::Atof(theArgVec[++i]);
+        const Standard_Real aY = Draw::Atof(theArgVec[++i]);
+        aClassifPnt.SetCoord(aX, aY);
+        break;
+      }
+
+      case 't':
+      {
+        aTolU = Draw::Atof(theArgVec[++i]);
+        aTolV = Draw::Atof(theArgVec[++i]);
+        break;
+      }
+
+      case 'p':
+        aCurv = DrawTrSurf::GetBSplineCurve2d(theArgVec[++i]);
+        break;
+    }
+  }
+
+  if (aCurv.IsNull())
+  {
+    theDI << "Polygon is not set. Please point to 2D B-spline curve.\n";
+    return 1;
+  }
+
+  const TColgp_Array1OfPnt2d &anArrPnts = aCurv->Poles();
+  Standard_Real aUmin = RealLast(), aUmax = RealFirst();
+  Standard_Real aVmin = RealLast(), aVmax = RealFirst();
+
+  for (Standard_Integer i = anArrPnts.Lower(); i <= anArrPnts.Upper(); i++)
+  {
+    const gp_Pnt2d &aP = anArrPnts(i);
+    aUmin = Min(aUmin, aP.X());
+    aUmax = Max(aUmax, aP.X());
+    aVmin = Min(aVmin, aP.Y());
+    aVmax = Max(aVmax, aP.Y());
+  }
+
+  CSLib_Class2d aPClass(anArrPnts, aTolU, aTolV, aUmin, aVmin, aUmax, aVmax);
+  CSLib_Class2d::PolyState aState = aPClass.Classify(aClassifPnt);
+
+  theDI << "The point is ";
+  switch(aState)
+  {
+    case CSLib_Class2d::PolyOut:
+      theDI << "OUT\n";
+      break;
+    case CSLib_Class2d::PolyOn:
+      theDI << "ON\n";
+      break;
+    case CSLib_Class2d::PolyIn:
+      theDI << "IN\n";
+      break;
+  }
+
+  return 0;
+}
+
+//=======================================================================
 //function : bhaspc
 //purpose  : 
 //=======================================================================
diff --git a/src/BOPTools/BOPTools_AlgoTools.cxx b/src/BOPTools/BOPTools_AlgoTools.cxx
index b5c07f0..4c8b546 100644
--- a/src/BOPTools/BOPTools_AlgoTools.cxx
+++ b/src/BOPTools/BOPTools_AlgoTools.cxx
@@ -1657,6 +1657,10 @@ void BOPTools_AlgoTools::MakeEdge(const IntTools_Curve& theIC,
   //
   BOPTools_AlgoTools::MakeSectEdge (theIC, theV1, theT1, theV2, theT2, 
                                     theE);
+
+  if (theE.IsNull())
+    return;
+
   //
   aBB.UpdateEdge(theE, theTolR3D);
 }
diff --git a/src/BOPTools/BOPTools_AlgoTools2D.cxx b/src/BOPTools/BOPTools_AlgoTools2D.cxx
index b24667e..babb563 100644
--- a/src/BOPTools/BOPTools_AlgoTools2D.cxx
+++ b/src/BOPTools/BOPTools_AlgoTools2D.cxx
@@ -298,7 +298,7 @@ void BOPTools_AlgoTools2D::AdjustPCurveOnSurf
    Handle(Geom2d_Curve)& aC2DA)
 {
   Standard_Boolean mincond, maxcond;
-  Standard_Real UMin, UMax, VMin, VMax, aT, u2, v2, du, dv, aDelta;
+  Standard_Real UMin, UMax, VMin, VMax, aT, u2, v2, du, dv;
   Standard_Real aUPeriod;
   //
   const TopoDS_Face& aF=aBAS.Face();
@@ -307,7 +307,7 @@ void BOPTools_AlgoTools2D::AdjustPCurveOnSurf
   VMin=aBAS.FirstVParameter();
   VMax=aBAS.LastVParameter();
   //
-  aDelta=Precision::PConfusion(); 
+  const Standard_Real aDelta=Precision::PConfusion();
   
   aT =.5*(aFirst+aLast);
 
@@ -390,7 +390,7 @@ void BOPTools_AlgoTools2D::AdjustPCurveOnSurf
         if ((u > (UMin + aDelta + aUPeriod)) ||
             (u < (UMax - aDelta - aUPeriod))) {
           BRepClass_FaceClassifier aClassifier;
-          aClassifier.Perform(aF, gp_Pnt2d(u, v), aDelta);
+          aClassifier.Perform(aF, gp_Pnt2d(u, v), BRep_Tool::Tolerance(aF));
           TopAbs_State Status = aClassifier.State();
           if (Status == TopAbs_OUT) {
             du += (u > (UMin + aDelta + aUPeriod)) ? -aUPeriod : aUPeriod;
@@ -406,7 +406,7 @@ void BOPTools_AlgoTools2D::AdjustPCurveOnSurf
         if ((v > (VMin + aDelta + aVPeriod)) ||
             (v < (VMax - aDelta - aVPeriod))) {
           BRepClass_FaceClassifier aClassifier;
-          aClassifier.Perform(aF, gp_Pnt2d(u, v), aDelta);
+          aClassifier.Perform(aF, gp_Pnt2d(u, v), BRep_Tool::Tolerance(aF));
           TopAbs_State Status = aClassifier.State();
           if (Status == TopAbs_OUT) {
             dv += (v > (VMin + aDelta + aVPeriod)) ? -aVPeriod : aVPeriod;
diff --git a/src/BOPTools/BOPTools_AlgoTools_2.cxx b/src/BOPTools/BOPTools_AlgoTools_2.cxx
index 9ed2175..98e8511 100644
--- a/src/BOPTools/BOPTools_AlgoTools_2.cxx
+++ b/src/BOPTools/BOPTools_AlgoTools_2.cxx
@@ -122,6 +122,12 @@ void BOPTools_AlgoTools::MakeSectEdge(const IntTools_Curve& aIC,
   
   BRepBuilderAPI_MakeEdge aMakeEdge(aC, aV1, aV2, aP1, aP2);
   
+  if (!aMakeEdge.IsDone())
+  {
+    aNewEdge.Nullify();
+    return;
+  }
+
   const TopoDS_Edge& aE=TopoDS::Edge(aMakeEdge.Shape());
   //
   // Range must be as it was !
diff --git a/src/BRep/BRep_Tool.hxx b/src/BRep/BRep_Tool.hxx
index ed66f84..9430dea 100644
--- a/src/BRep/BRep_Tool.hxx
+++ b/src/BRep/BRep_Tool.hxx
@@ -218,6 +218,8 @@ public:
   Standard_EXPORT static void UVPoints (const TopoDS_Edge& E, const Handle(Geom_Surface)& S, const TopLoc_Location& L, gp_Pnt2d& PFirst, gp_Pnt2d& PLast);
   
   //! Gets the UV locations of the extremities of the edge.
+  //! It does not take into account the orientation of E and F
+  //! (i.e. returns first and last points of CurveOnSurface)
   Standard_EXPORT static void UVPoints (const TopoDS_Edge& E, const TopoDS_Face& F, gp_Pnt2d& PFirst, gp_Pnt2d& PLast);
   
   //! Sets the UV locations of the extremities of the edge.
diff --git a/src/BRepAlgo/BRepAlgo_FaceRestrictor.cxx b/src/BRepAlgo/BRepAlgo_FaceRestrictor.cxx
index f01b28b..a89605f 100644
--- a/src/BRepAlgo/BRepAlgo_FaceRestrictor.cxx
+++ b/src/BRepAlgo/BRepAlgo_FaceRestrictor.cxx
@@ -250,8 +250,7 @@ static Standard_Boolean IsClosed (const TopoDS_Wire& W)
 //=======================================================================
 
 static Standard_Boolean IsInside(const TopoDS_Wire&       wir,
-                                 const TopoDS_Face&       F,
-                                 BRepTopAdaptor_FClass2d& /*FClass2d*/)
+                                 const TopoDS_Face&       F)
 {
   TopExp_Explorer exp;
   exp.Init(wir,TopAbs_EDGE);
@@ -277,9 +276,9 @@ static Standard_Boolean IsInside(const TopoDS_Wire&       wir,
     }
 
     gp_Pnt2d pt2d(C2d->Value(prm));
-    BRepTopAdaptor_FClass2d FClass2d(F,Precision::PConfusion());
+    BRepTopAdaptor_FClass2d FClass2d(F,Precision::Confusion());
     TopAbs_State st2=FClass2d.Perform(pt2d,Standard_False);
-    return(st2 == TopAbs_IN);     
+    return(st2 == TopAbs_IN);
   }
   return Standard_False;
 }
@@ -393,7 +392,7 @@ void BRepAlgo_FaceRestrictor::PerformWithCorrection()
     B.Add(NF,W);
     
     if (IsClosed(W)) {  
-      BRepTopAdaptor_FClass2d FClass2d(NF,Precision::PConfusion());
+      BRepTopAdaptor_FClass2d FClass2d(NF,Precision::Confusion());
       if(FClass2d.PerformInfinitePoint() != TopAbs_OUT) { 
         W.Reverse();
       }
@@ -416,10 +415,9 @@ void BRepAlgo_FaceRestrictor::PerformWithCorrection()
       NF.Orientation(TopAbs_FORWARD);
       B.Add(NF,W1);
       
-      BRepTopAdaptor_FClass2d FClass2d(NF,Precision::PConfusion());
       while (it2.More()) {
         const TopoDS_Wire& W2 = TopoDS::Wire(it2.Value());
-        if (!W1.IsSame(W2) && IsInside (W2,NF,FClass2d)) {
+        if (!W1.IsSame(W2) && IsInside (W2,NF)) {
           Store (W2,W1,keyIsIn,keyContains);
         } 
         it2.Next();
diff --git a/src/BRepBlend/BRepBlend_CSWalking.hxx b/src/BRepBlend/BRepBlend_CSWalking.hxx
index 27cbe6d..5f7798b 100644
--- a/src/BRepBlend/BRepBlend_CSWalking.hxx
+++ b/src/BRepBlend/BRepBlend_CSWalking.hxx
@@ -97,8 +97,8 @@ private:
   Handle(BRepBlend_Line) line;
   Handle(Adaptor3d_HSurface) surf;
   Handle(Adaptor3d_HCurve) curv;
-  Handle(Adaptor3d_TopolTool) domain;
-  Standard_Real tolesp;
+  Handle(Adaptor3d_TopolTool) myDomain;
+  Standard_Real my3DTolEsp;
   Standard_Real tolgui;
   Standard_Real pasmax;
   Standard_Real fleche;
